<template>
  <v-dialog v-model="isOpen" max-width="400px">
    <v-card>
      <v-card-title>
        {{ $t('courses.confirm.sure') }}

        <v-spacer />
      </v-card-title>

      <!-- Content -->
      <v-card-content>
        <!-- Description -->
        <slot name="description" />
      </v-card-content>

      <!-- Actions -->
      <v-card-actions>
        <v-spacer />

        <!-- Confirm -->
        <v-btn
          class="studium-button"
          color="primary"
          text
          large
          :ripple="false"
          :loading="isLoading"
          @click="onConfirm"
        >
          {{ $t('courses.confirm.confirm') }}
        </v-btn>

        <!-- Cancel -->
        <v-btn class="studium-button" color="secondary" text large :ripple="false" @click="onCancel">
          {{ $t('courses.confirm.cancel') }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

export default defineComponent({
  props: {
    // Synchronised property if the dialog is open
    open: {
      type: Boolean,
      default: false,
    },

    // Synchronised property if the dialog is loading
    loading: {
      type: Boolean,
      default: false,
    },
  },
  setup(props, { emit }) {
    const isOpen = useVModel(props, 'open', emit)

    // If the dialog is loading
    const isLoading = useVModel(props, 'loading', emit)

    // When the confirm button is pressed.
    function onConfirm() {
      emit('confirm')
    }

    // When the cancel button is pressed.
    function onCancel() {
      emit('cancel')
    }

    return {
      isOpen,
      isLoading,
      onConfirm,
      onCancel,
    }
  },
})
</script>
